diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/helper/group-mobility-helper.h ns-3.35/src/mobility/helper/group-mobility-helper.h
--- ns-3.34/src/mobility/helper/group-mobility-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.35/src/mobility/helper/group-mobility-helper.h	2021-10-01 13:26:47.000000000 -0700
@@ -0,0 +1,289 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2008 INRIA
+ * Copyright (c) 2021 University of Washington: Group mobility changes
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Adapted from 'mobility-helper.h' for group mobility by Tom Henderson
+ */
+
+#ifndef GROUP_MOBILITY_HELPER_H
+#define GROUP_MOBILITY_HELPER_H
+
+#include <vector>
+#include "ns3/object-factory.h"
+#include "ns3/attribute.h"
+#include "ns3/node-container.h"
+
+namespace ns3 {
+
+class PositionAllocator;
+class MobilityModel;
+
+/**
+ * \ingroup mobility
+ * \brief Helper class used to assign positions and mobility models to nodes
+ * for a group mobility configuration.
+ *
+ * This helper can be used for group mobility configuration and installation
+ * onto a group of nodes, in which there is a reference (parent) mobility
+ * model that is the same for all nodes, and similarly configured (but
+ * distinct) child mobility models.
+ */
+class GroupMobilityHelper
+{
+public:
+  /**
+   * Construct a group mobility helper 
+   */
+  GroupMobilityHelper ();
+
+  /**
+   * Destroy a group mobility helper
+   */
+  ~GroupMobilityHelper ();
+
+  /**
+   * Set the position allocator which will be used to allocate the initial 
+   * position of the reference mobility model.
+   *
+   * \param allocator allocate initial reference mobility model position
+   */
+  void SetReferencePositionAllocator (Ptr<PositionAllocator> allocator);
+
+  /**
+   * Configure the position allocator which will be used to allocate
+   * the initial position of the reference mobility model.
+   *
+   * \param type the type of mobility model to use.
+   * \param n1 the name of the attribute to set in the mobility model.
+   * \param v1 the value of the attribute to set in the mobility model.
+   * \param n2 the name of the attribute to set in the mobility model.
+   * \param v2 the value of the attribute to set in the mobility model.
+   * \param n3 the name of the attribute to set in the mobility model.
+   * \param v3 the value of the attribute to set in the mobility model.
+   * \param n4 the name of the attribute to set in the mobility model.
+   * \param v4 the value of the attribute to set in the mobility model.
+   * \param n5 the name of the attribute to set in the mobility model.
+   * \param v5 the value of the attribute to set in the mobility model.
+   * \param n6 the name of the attribute to set in the mobility model.
+   * \param v6 the value of the attribute to set in the mobility model.
+   * \param n7 the name of the attribute to set in the mobility model.
+   * \param v7 the value of the attribute to set in the mobility model.
+   * \param n8 the name of the attribute to set in the mobility model.
+   * \param v8 the value of the attribute to set in the mobility model.
+   * \param n9 the name of the attribute to set in the mobility model.
+   * \param v9 the value of the attribute to set in the mobility model.
+   */
+  void SetReferencePositionAllocator (std::string type,
+                             std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
+                             std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
+                             std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
+                             std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
+                             std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
+                             std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
+                             std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue (),
+                             std::string n8 = "", const AttributeValue &v8 = EmptyAttributeValue (),
+                             std::string n9 = "", const AttributeValue &v9 = EmptyAttributeValue ());
+
+  /**
+   * Set the position allocator which will be used to allocate the initial 
+   * position of the member mobility models.
+   *
+   * \param allocator allocate initial member mobility model positions
+   */
+  void SetMemberPositionAllocator (Ptr<PositionAllocator> allocator);
+
+  /**
+   * Configure the position allocator which will be used to allocate the
+   * initial position of the member mobility models.
+   *
+   * \param type the type of mobility model to use.
+   * \param n1 the name of the attribute to set in the mobility model.
+   * \param v1 the value of the attribute to set in the mobility model.
+   * \param n2 the name of the attribute to set in the mobility model.
+   * \param v2 the value of the attribute to set in the mobility model.
+   * \param n3 the name of the attribute to set in the mobility model.
+   * \param v3 the value of the attribute to set in the mobility model.
+   * \param n4 the name of the attribute to set in the mobility model.
+   * \param v4 the value of the attribute to set in the mobility model.
+   * \param n5 the name of the attribute to set in the mobility model.
+   * \param v5 the value of the attribute to set in the mobility model.
+   * \param n6 the name of the attribute to set in the mobility model.
+   * \param v6 the value of the attribute to set in the mobility model.
+   * \param n7 the name of the attribute to set in the mobility model.
+   * \param v7 the value of the attribute to set in the mobility model.
+   * \param n8 the name of the attribute to set in the mobility model.
+   * \param v8 the value of the attribute to set in the mobility model.
+   * \param n9 the name of the attribute to set in the mobility model.
+   * \param v9 the value of the attribute to set in the mobility model.
+   */
+  void SetMemberPositionAllocator (std::string type,
+                             std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
+                             std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
+                             std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
+                             std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
+                             std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
+                             std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
+                             std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue (),
+                             std::string n8 = "", const AttributeValue &v8 = EmptyAttributeValue (),
+                             std::string n9 = "", const AttributeValue &v9 = EmptyAttributeValue ());
+
+  /**
+   * Set the reference mobility model which will be installed as the parent
+   * mobility model during GroupMobilityModel::Install.
+   *
+   * \param mobility reference mobility model
+   */
+  void SetReferenceMobilityModel (Ptr<MobilityModel> mobility);
+
+  /**
+   * Configure the reference mobility model which will be installed as the
+   * parent mobility model during GroupMobilityModel::Install.
+   *
+   * \param type the type of mobility model to use.
+   * \param n1 the name of the attribute to set in the mobility model.
+   * \param v1 the value of the attribute to set in the mobility model.
+   * \param n2 the name of the attribute to set in the mobility model.
+   * \param v2 the value of the attribute to set in the mobility model.
+   * \param n3 the name of the attribute to set in the mobility model.
+   * \param v3 the value of the attribute to set in the mobility model.
+   * \param n4 the name of the attribute to set in the mobility model.
+   * \param v4 the value of the attribute to set in the mobility model.
+   * \param n5 the name of the attribute to set in the mobility model.
+   * \param v5 the value of the attribute to set in the mobility model.
+   * \param n6 the name of the attribute to set in the mobility model.
+   * \param v6 the value of the attribute to set in the mobility model.
+   * \param n7 the name of the attribute to set in the mobility model.
+   * \param v7 the value of the attribute to set in the mobility model.
+   * \param n8 the name of the attribute to set in the mobility model.
+   * \param v8 the value of the attribute to set in the mobility model.
+   * \param n9 the name of the attribute to set in the mobility model.
+   * \param v9 the value of the attribute to set in the mobility model.
+   */
+  void SetReferenceMobilityModel (std::string type,
+                         std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
+                         std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
+                         std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
+                         std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
+                         std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
+                         std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
+                         std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue (),
+                         std::string n8 = "", const AttributeValue &v8 = EmptyAttributeValue (),
+                         std::string n9 = "", const AttributeValue &v9 = EmptyAttributeValue ());
+
+  /**
+   * Configure the mobility model which will be installed as the
+   * member (child) mobility model during GroupMobilityModel::Install.
+   * 
+   * \param type the type of mobility model to use.
+   * \param n1 the name of the attribute to set in the mobility model.
+   * \param v1 the value of the attribute to set in the mobility model.
+   * \param n2 the name of the attribute to set in the mobility model.
+   * \param v2 the value of the attribute to set in the mobility model.
+   * \param n3 the name of the attribute to set in the mobility model.
+   * \param v3 the value of the attribute to set in the mobility model.
+   * \param n4 the name of the attribute to set in the mobility model.
+   * \param v4 the value of the attribute to set in the mobility model.
+   * \param n5 the name of the attribute to set in the mobility model.
+   * \param v5 the value of the attribute to set in the mobility model.
+   * \param n6 the name of the attribute to set in the mobility model.
+   * \param v6 the value of the attribute to set in the mobility model.
+   * \param n7 the name of the attribute to set in the mobility model.
+   * \param v7 the value of the attribute to set in the mobility model.
+   * \param n8 the name of the attribute to set in the mobility model.
+   * \param v8 the value of the attribute to set in the mobility model.
+   * \param n9 the name of the attribute to set in the mobility model.
+   * \param v9 the value of the attribute to set in the mobility model.
+   *
+   * Calls to MobilityHelper::Install will create an instance of a matching 
+   * mobility model for each node.
+   */
+  void SetMemberMobilityModel (std::string type,
+                         std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
+                         std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
+                         std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
+                         std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
+                         std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
+                         std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
+                         std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue (),
+                         std::string n8 = "", const AttributeValue &v8 = EmptyAttributeValue (),
+                         std::string n9 = "", const AttributeValue &v9 = EmptyAttributeValue ());
+
+  /**
+   * \brief Install and configure a hierarchical mobility model to the
+   * given node, based on the configured reference and member models.
+   *
+   * If position allocators are configured, they will be invoked to
+   * set the initial position.
+   *
+   * \param node The node to configure
+   */
+  void Install (Ptr<Node> node);
+  /**
+   * \brief Install and configure a hierarchical mobility model to the
+   * given node, based on the configured reference and member models.
+   *
+   * If position allocators are configured, they will be invoked to
+   * set the initial position.
+   *
+   * \param nodeName The name of the node to configure
+   */
+  void Install (std::string nodeName);
+
+  /**
+   * \brief Install and configure a hierarchical mobility model to all nodes
+   * in the container, based on the configured reference and member models.
+   *
+   * If position allocators are configured, they will be invoked to
+   * set the initial positions.
+   *
+   * \param container The set of nodes to configure
+   */
+  void Install (NodeContainer container);
+
+  /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by the mobility models on these nodes. Return the number of 
+   * streams (possibly zero) that have been assigned. The Install() 
+   * method should have previously been called by the user.
+   *
+   * \note If the PositionAllocator used contains random variables, they
+   * will not be affected by this call to AssignStreams because they are
+   * used earlier during Install() time.  If the user needs to assign a fixed
+   * stream number to a PositionAllocator used with this helper, the user
+   * should instantiate it outside of the helper, call AssignStreams() on
+   * it, and then pass the pointer of it to this helper.
+   *
+   * \param c NodeContainer of the set of nodes containing the MobilityModels
+   * that should be modified to use a fixed stream
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this helper
+   */
+  int64_t AssignStreams (NodeContainer c, int64_t stream);
+
+private:
+
+  bool m_referencePositionSet {false}; //!< flag for avoiding multiple SetPosition calls on the reference model
+  Ptr<MobilityModel> m_referenceMobility; //!< Reference mobility model
+  Ptr<PositionAllocator> m_referencePosition; //!< Position allocator for use as reference position allocator
+  ObjectFactory  m_memberMobilityFactory; //!< Object factory to create member mobility models
+  Ptr<PositionAllocator> m_memberPosition; //!< Position allocator for use as member position allocator
+};
+
+} // namespace ns3
+
+#endif /* GROUP_MOBILITY_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/helper/mobility-helper.cc ns-3.35/src/mobility/helper/mobility-helper.cc
--- ns-3.34/src/mobility/helper/mobility-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/helper/mobility-helper.cc	2021-10-01 13:26:47.000000000 -0700
@@ -209,14 +209,13 @@
 MobilityHelper::CourseChanged (Ptr<OutputStreamWrapper> stream, Ptr<const MobilityModel> mobility)
 {
   std::ostream* os = stream->GetStream ();
-  Ptr<Node> node = mobility->GetObject<Node> ();
-  *os << "now=" << Simulator::Now ()
-      << " node=" << node->GetId ();
   Vector pos = mobility->GetPosition ();
+  Vector vel = mobility->GetVelocity ();
+  *os << "now=" << Simulator::Now ()
+      << " node=" << mobility->GetObject<Node> ()->GetId ();
   pos.x = DoRound (pos.x);
   pos.y = DoRound (pos.y);
   pos.z = DoRound (pos.z);
-  Vector vel = mobility->GetVelocity ();
   vel.x = DoRound (vel.x);
   vel.y = DoRound (vel.y);
   vel.z = DoRound (vel.z);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/helper/mobility-helper.h ns-3.35/src/mobility/helper/mobility-helper.h
--- ns-3.34/src/mobility/helper/mobility-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/helper/mobility-helper.h	2021-10-01 13:26:47.000000000 -0700
@@ -251,14 +251,20 @@
   static void EnableAsciiAll (Ptr<OutputStreamWrapper> stream);
   /**
    * Assign a fixed random variable stream number to the random variables
-   * used by the mobility models (including any position allocators assigned
-   * specifically to the model) on these nodes. Return the number of 
+   * used by the mobility models on these nodes. Return the number of 
    * streams (possibly zero) that have been assigned. The Install() 
    * method should have previously been called by the user.
    *
-   * \param stream first stream index to use
+   * \note If the PositionAllocator used contains random variables, they
+   * will not be affected by this call to AssignStreams because they are
+   * used earlier during Install() time.  If the user needs to assign a fixed
+   * stream number to a PositionAllocator used with this helper, the user
+   * should instantiate it outside of the helper, call AssignStreams() on
+   * it, and then pass the pointer of it to this helper.
+   *
    * \param c NodeContainer of the set of nodes for which the MobilityModels
    * should be modified to use a fixed stream
+   * \param stream first stream index to use
    * \return the number of stream indices assigned by this helper
    */
   int64_t AssignStreams (NodeContainer c, int64_t stream);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/model/hierarchical-mobility-model.cc ns-3.35/src/mobility/model/hierarchical-mobility-model.cc
--- ns-3.34/src/mobility/model/hierarchical-mobility-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/model/hierarchical-mobility-model.cc	2021-10-01 13:26:47.000000000 -0700
@@ -19,9 +19,13 @@
  */
 #include "hierarchical-mobility-model.h"
 #include "ns3/pointer.h"
+#include "ns3/log.h"
+#include "ns3/simulator.h"
 
 namespace ns3 {
 
+NS_LOG_COMPONENT_DEFINE ("HierarchicalMobilityModel");
+
 NS_OBJECT_ENSURE_REGISTERED (HierarchicalMobilityModel);
 
 TypeId 
@@ -49,15 +53,18 @@
   : m_child (0),
     m_parent (0)
 {
+  NS_LOG_FUNCTION (this);
 }
 
 void
 HierarchicalMobilityModel::SetChild (Ptr<MobilityModel> model)
 {
+  NS_LOG_FUNCTION (this << model);
   Ptr<MobilityModel> oldChild = m_child;
   Vector pos;
   if (m_child)
     {
+      NS_LOG_DEBUG ("Disconnecting previous child model " << m_child);
       pos = GetPosition ();
       m_child->TraceDisconnectWithoutContext ("CourseChange", MakeCallback (&HierarchicalMobilityModel::ChildChanged, this));
     }
@@ -68,6 +75,7 @@
   // try to preserve the old absolute position.
   if (oldChild)
     {
+      NS_LOG_DEBUG ("Restoring previous position " << pos);
       SetPosition (pos);
     }
 }
@@ -75,6 +83,7 @@
 void 
 HierarchicalMobilityModel::SetParent (Ptr<MobilityModel> model)
 {
+  NS_LOG_FUNCTION (this << model);
   Vector pos;
   if (m_child)
     {
@@ -82,6 +91,7 @@
     }
   if (m_parent)
     {
+      NS_LOG_DEBUG ("Disconnecting previous parent model " << m_child);
       m_parent->TraceDisconnectWithoutContext ("CourseChange", MakeCallback (&HierarchicalMobilityModel::ParentChanged, this));
     }
   m_parent = model;
@@ -92,6 +102,7 @@
   // try to preserve the old position across parent changes
   if (m_child)
     {
+      NS_LOG_DEBUG ("Restoring previous position " << pos);
       SetPosition (pos);
     }
 }
@@ -117,7 +128,7 @@
       return m_child->GetPosition ();
     }
   Vector parentPosition = m_parent->GetPosition ();
-  Vector childPosition = m_child->GetPosition ();
+  Vector childPosition = m_child->GetPositionWithReference (parentPosition);
   return Vector (parentPosition.x + childPosition.x,
                  parentPosition.y + childPosition.y,
                  parentPosition.z + childPosition.z);
@@ -125,6 +136,7 @@
 void 
 HierarchicalMobilityModel::DoSetPosition (const Vector &position)
 {
+  NS_LOG_FUNCTION (this << position);
   if (m_child == 0)
     {
       return;
@@ -174,6 +186,25 @@
   MobilityModel::NotifyCourseChange ();
 }
 
+void
+HierarchicalMobilityModel::DoInitialize (void)
+{
+  NS_LOG_FUNCTION (this);
+  if (m_parent && !m_parent->IsInitialized ())
+    {
+      m_parent->Initialize ();
+    }
+  m_child->Initialize ();
+}
 
+int64_t
+HierarchicalMobilityModel::DoAssignStreams (int64_t stream)
+{
+  NS_LOG_FUNCTION (this << stream);
+  int64_t streamsAllocated = 0;
+  streamsAllocated += m_parent->AssignStreams (stream);
+  streamsAllocated += m_child->AssignStreams (stream + streamsAllocated);
+  return streamsAllocated;
+}
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/model/hierarchical-mobility-model.h ns-3.35/src/mobility/model/hierarchical-mobility-model.h
--- ns-3.34/src/mobility/model/hierarchical-mobility-model.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/model/hierarchical-mobility-model.h	2021-10-01 13:26:47.000000000 -0700
@@ -68,31 +68,33 @@
   /**
    * \return the child mobility model.
    *
-   * This allows you to get access to the position of the child
-   * relative to its parent.
+   * Calling GetPosition() on the model returned by this method allows
+   * one to access the position of the child relative to its parent.
    */
   Ptr<MobilityModel> GetChild (void) const;
   /**
    * \return the parent mobility model.
    *
-   * This allows you to get access to the position of the 
-   * parent mobility model which is used as the reference 
-   * position by the child mobility model.
+   * Calling GetPosition() on the model returned by this method allows
+   * one to access the position of the parent alone, which is used
+   * as the reference position to which the child position is added.
    */
   Ptr<MobilityModel> GetParent (void) const;
   /**
-   * Sets the child mobility model to a new one.  If before there
-   * already existed a child model, then the child mobility model
-   * current position is also modified to ensure that the composite
-   * position is preserved.
+   * Sets the child mobility model to a new one, possibly replacing
+   * an existing one.  If the child model is being replaced,
+   * then the new child mobility model's current position is also set to
+   * the previous position to ensure that the composite
+   * position is preserved by this operation.
    * \param model new mobility model child
    */
   void SetChild (Ptr<MobilityModel> model);
   /**
-   * Sets the parent mobility model to a new one.  If before there
-   * already existed a child model, then the child mobility model
-   * current position is also modified to ensure that the composite
-   * position is preserved.
+   * Sets the parent mobility model to a new one, possibly replacing
+   * an existing one.  If the parent model is being replaced,
+   * then the new position is set to the position that was set before
+   * replacement, to ensure that the composite position is preserved
+   * across changes to the parent model.
    * \param model new mobility model parent
    */
   void SetParent (Ptr<MobilityModel> model);
@@ -101,6 +103,8 @@
   virtual Vector DoGetPosition (void) const;
   virtual void DoSetPosition (const Vector &position);
   virtual Vector DoGetVelocity (void) const;
+  virtual void DoInitialize (void);
+  virtual int64_t DoAssignStreams (int64_t);
 
   /**
    * Callback for when parent mobility model course change occurs
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/model/mobility-model.cc ns-3.35/src/mobility/model/mobility-model.cc
--- ns-3.34/src/mobility/model/mobility-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/model/mobility-model.cc	2021-10-01 13:26:47.000000000 -0700
@@ -66,6 +66,19 @@
   return DoGetPosition ();
 }
 Vector
+MobilityModel::GetPositionWithReference (const Vector& referencePosition) const
+{
+  return DoGetPositionWithReference (referencePosition);
+}
+
+// Default implementation ignores referencePosition
+Vector
+MobilityModel::DoGetPositionWithReference (const Vector& referencePosition) const
+{
+  return DoGetPosition ();
+}
+
+Vector
 MobilityModel::GetVelocity (void) const
 {
   return DoGetVelocity ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/model/mobility-model.h ns-3.35/src/mobility/model/mobility-model.h
--- ns-3.34/src/mobility/model/mobility-model.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/model/mobility-model.h	2021-10-01 13:26:47.000000000 -0700
@@ -52,6 +52,18 @@
    */
   Vector GetPosition (void) const;
   /**
+   * This method may be used if the position returned may depend on some
+   * reference position provided.  For example, in a hierarchical mobility
+   * model that is buildings-aware, the child mobility model may not be able
+   * to determine if it is inside or outside of a building unless it knows
+   * the parent position.
+   *
+   * \param referencePosition reference position to consider
+   * \return the current position based on the provided referencePosition
+   * \sa ns3::MobilityModel::DoGetPositionWithReference
+   */
+  Vector GetPositionWithReference (const Vector &referencePosition) const;
+  /**
    * \param position the position to set.
    */
   void SetPosition (const Vector &position);
@@ -101,6 +113,14 @@
    */
   virtual Vector DoGetPosition (void) const = 0;
   /**
+   * \param referencePosition the reference position to consider
+   * \return the current position.
+   *
+   * Unless subclasses override, this method will disregard the reference
+   * position and return "DoGetPosition (void)".
+   */
+  virtual Vector DoGetPositionWithReference (const Vector& referencePosition) const;
+  /**
    * \param position the position to set.
    *
    * Concrete subclasses of this base class must 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/test/examples-to-run.py ns-3.35/src/mobility/test/examples-to-run.py
--- ns-3.34/src/mobility/test/examples-to-run.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/test/examples-to-run.py	2021-10-01 13:26:47.000000000 -0700
@@ -11,6 +11,8 @@
     ("main-grid-topology", "True", "True"),
     ("main-random-topology", "True", "True"),
     ("main-random-walk", "True", "True"),
+    ("reference-point-group-mobility-example --useHelper=0", "True", "True"),
+    ("reference-point-group-mobility-example --useHelper=1", "True", "True"),
 ]
 
 # A list of Python examples to run in order to ensure that they remain
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mobility/wscript ns-3.35/src/mobility/wscript
--- ns-3.34/src/mobility/wscript	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mobility/wscript	2021-10-01 13:26:47.000000000 -0700
@@ -22,6 +22,7 @@
         'model/waypoint-mobility-model.cc',
         'helper/mobility-helper.cc',
         'helper/ns2-mobility-helper.cc',
+        'helper/group-mobility-helper.cc',
         ]
 
     mobility_test = bld.create_ns3_module_test_library('mobility')
@@ -64,6 +65,7 @@
         'model/waypoint-mobility-model.h',
         'helper/mobility-helper.h',
         'helper/ns2-mobility-helper.h',
+        'helper/group-mobility-helper.h',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mpi/examples/nms-p2p-nix-distributed.cc ns-3.35/src/mpi/examples/nms-p2p-nix-distributed.cc
--- ns-3.34/src/mpi/examples/nms-p2p-nix-distributed.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mpi/examples/nms-p2p-nix-distributed.cc	2021-10-01 13:26:47.000000000 -0700
@@ -47,7 +47,7 @@
 #include "ns3/packet-sink-helper.h"
 #include "ns3/point-to-point-helper.h"
 #include "ns3/mpi-interface.h"
-#include "ns3/ipv4-nix-vector-helper.h"
+#include "ns3/nix-vector-helper.h"
 
 #include <fstream>
 #include <vector>
@@ -283,7 +283,7 @@
         {
           oss.str ("");
           oss << 10 + z << ".5." << 10 + i << ".0";
-          address.SetBase (oss.str ().c_str (), "255.255.255.255");
+          address.SetBase (oss.str ().c_str (), "255.255.255.0");
           for (uint32_t j = 0; j < nLANClients; ++j)
             {
               Ptr<Node> node = CreateObject<Node> (z % systemCount);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mpi/examples/simple-distributed.cc ns-3.35/src/mpi/examples/simple-distributed.cc
--- ns-3.34/src/mpi/examples/simple-distributed.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mpi/examples/simple-distributed.cc	2021-10-01 13:26:47.000000000 -0700
@@ -53,7 +53,7 @@
 #include "ns3/ipv4-global-routing-helper.h"
 #include "ns3/point-to-point-helper.h"
 #include "ns3/internet-stack-helper.h"
-#include "ns3/ipv4-nix-vector-helper.h"
+#include "ns3/nix-vector-helper.h"
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mpi/examples/simple-distributed-empty-node.cc ns-3.35/src/mpi/examples/simple-distributed-empty-node.cc
--- ns-3.34/src/mpi/examples/simple-distributed-empty-node.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mpi/examples/simple-distributed-empty-node.cc	2021-10-01 13:26:47.000000000 -0700
@@ -72,7 +72,7 @@
 #include "ns3/ipv4-global-routing-helper.h"
 #include "ns3/point-to-point-helper.h"
 #include "ns3/internet-stack-helper.h"
-#include "ns3/ipv4-nix-vector-helper.h"
+#include "ns3/nix-vector-helper.h"
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/mpi/examples/simple-distributed-mpi-comm.cc ns-3.35/src/mpi/examples/simple-distributed-mpi-comm.cc
--- ns-3.34/src/mpi/examples/simple-distributed-mpi-comm.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/mpi/examples/simple-distributed-mpi-comm.cc	2021-10-01 13:26:47.000000000 -0700
@@ -65,7 +65,7 @@
 #include "ns3/ipv4-list-routing-helper.h"
 #include "ns3/point-to-point-helper.h"
 #include "ns3/internet-stack-helper.h"
-#include "ns3/ipv4-nix-vector-helper.h"
+#include "ns3/nix-vector-helper.h"
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink.h"
